<?php
/*
Plugin Name: Image With Text
Plugin URI: https://virtualtopia.com/featured-image-lightbox/
Description: A plugin to display an image with text overlay using shortcode.
Version: 1.7
Author: Virtualtopia
Author URI: https://virtualtopia.com/
License: GPLv2 or later
Text Domain: random-post-widget
Domain Path: /languages
*/

// Add shortcode
function image_with_text_shortcode($atts) {
    $atts = shortcode_atts(
        array(
            'src' => '',
            'text1' => '',
            'font_color1' => 'white',
            'font_size1' => '24px',
            'bold1' => 'false',
            'text2' => '',
            'font_color2' => 'white',
            'font_size2' => '24px',
            'bold2' => 'false',
            'text3' => '',
            'font_color3' => 'white',
            'font_size3' => '24px',
            'bold3' => 'false',
            'bg_opacity' => '0',  // Set default opacity to 0
            'text_align' => 'center',  // Set default text alignment to center
        ), $atts, 'image_with_text'
    );

    if (!$atts['src'] || !$atts['text1']) {
        return 'Image source and the first line of text are required.';
    }

    // Line 1 properties
    $font_color1 = esc_attr($atts['font_color1']);
    $font_size1 = esc_attr($atts['font_size1']);
    $bold1 = esc_attr($atts['bold1']);
    $font_weight1 = $bold1 === 'true' ? 'bold' : 'normal';

    // Line 2 properties
    $font_color2 = esc_attr($atts['font_color2']);
    $font_size2 = esc_attr($atts['font_size2']);
    $bold2 = esc_attr($atts['bold2']);
    $font_weight2 = $bold2 === 'true' ? 'bold' : 'normal';

    // Line 3 properties
    $font_color3 = esc_attr($atts['font_color3']);
    $font_size3 = esc_attr($atts['font_size3']);
    $bold3 = esc_attr($atts['bold3']);
    $font_weight3 = $bold3 === 'true' ? 'bold' : 'normal';

    $bg_opacity = floatval($atts['bg_opacity']);
    $text_align = esc_attr($atts['text_align']);

    return '<div style="position: relative; display: inline-block; max-width: 100%; height: auto;">
                <img src="' . esc_url($atts['src']) . '" alt="" style="display: block; width: 100%; height: auto;">
                <div style="position: absolute; top: 50%; left: 50%; transform: translate(-50%, -50%); background-color: rgba(0, 0, 0, ' . $bg_opacity . '); padding: 5px; text-align: ' . $text_align . ';">
                    <div style="font-size: ' . $font_size1 . '; font-weight: ' . $font_weight1 . '; color: ' . $font_color1 . ';">
                        ' . esc_html($atts['text1']) . '
                    </div>
                    <div style="font-size: ' . $font_size2 . '; font-weight: ' . $font_weight2 . '; color: ' . $font_color2 . '; margin-top: 10px;">
                        ' . esc_html($atts['text2']) . '
                    </div>
                    <div style="font-size: ' . $font_size3 . '; font-weight: ' . $font_weight3 . '; color: ' . $font_color3 . '; margin-top: 10px;">
                        ' . esc_html($atts['text3']) . '
                    </div>
                </div>
            </div>';
}
add_shortcode('image_with_text', 'image_with_text_shortcode');
?>
